Package org.flowable.cmmn.api.migration

# Interface HistoricCaseInstanceMigrationBuilder

public interface HistoricCaseInstanceMigrationBuilder

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Batch`
  `batchMigrateHistoricCaseInstances(String caseDefinitionId)`
  Starts the case instance migration for all case instances of a given case definition identified by the case definition id.
  `Batch`
  `batchMigrateHistoricCaseInstances(String caseDefinitionKey, int caseDefinitionVersion, String caseDefinitionTenantId)`
  Asynchronously starts the case instance migration for each case instances of a given case definition identified by the case definition key and version (optional tenantId).
  `HistoricCaseInstanceMigrationBuilder`
  `fromHistoricCaseInstanceMigrationDocument(HistoricCaseInstanceMigrationDocument historicCaseInstanceMigrationDocument)`
  Creates a HistoricCaseInstanceMigrationBuilder using the values of a HistoricCaseInstanceMigrationDocument
  `HistoricCaseInstanceMigrationDocument`
  `getHistoricCaseInstanceMigrationDocument()`
  Builds a HistoricCaseInstanceMigrationDocument
  `void`
  `migrate(String caseInstanceId)`
  Starts the case instance migration for a case identified with the submitted caseInstanceId
  `void`
  `migrateHistoricCaseInstances(String caseDefinitionId)`
  Asynchronously starts the case instance migration for each case instances of a given case definition identified by the case definition id.
  `void`
  `migrateHistoricCaseInstances(String caseDefinitionKey, int caseDefinitionVersion, String caseDefinitionTenantId)`
  Starts the case instance migration for all case instances of a given case definition identified by the case definition key and version (optional tenantId).
  `HistoricCaseInstanceMigrationBuilder`
  `migrateToCaseDefinition(String caseDefinitionId)`
  Specifies the case definition to migrate to, using the case definition id
  `HistoricCaseInstanceMigrationBuilder`
  `migrateToCaseDefinition(String caseDefinitionKey, int caseDefinitionVersion)`
  Specifies the case definition to migrate to, identified by its key and version
  `HistoricCaseInstanceMigrationBuilder`
  `migrateToCaseDefinition(String caseDefinitionKey, int caseDefinitionVersion, String caseDefinitionTenantId)`
  Specifies the case definition to migrate to, identified by its key and version and tenantId
  `HistoricCaseInstanceMigrationBuilder`
  `withMigrateToCaseDefinitionTenantId(String caseDefinitionTenantId)`
  Specifies the tenantId of the case definition to migrate to

- ## Method Details

  - ### fromHistoricCaseInstanceMigrationDocument

    HistoricCaseInstanceMigrationBuilder fromHistoricCaseInstanceMigrationDocument(HistoricCaseInstanceMigrationDocument historicCaseInstanceMigrationDocument)
    Creates a HistoricCaseInstanceMigrationBuilder using the values of a HistoricCaseInstanceMigrationDocument
    Parameters:
      `historicCaseInstanceMigrationDocument` - Migration document with pre-filled case information
    Returns:
      Returns the builder
    See Also:
      - `HistoricCaseInstanceMigrationDocument`

  - ### migrateToCaseDefinition

    HistoricCaseInstanceMigrationBuilder migrateToCaseDefinition(String caseDefinitionId)
    Specifies the case definition to migrate to, using the case definition id
    Parameters:
      `caseDefinitionId` - ID of the case definition to migrate to
    Returns:
      Returns the builder
    See Also:
      - `CaseDefinition`

  - ### migrateToCaseDefinition

    HistoricCaseInstanceMigrationBuilder migrateToCaseDefinition(String caseDefinitionKey, int caseDefinitionVersion)
    Specifies the case definition to migrate to, identified by its key and version
    Parameters:
      `caseDefinitionKey` - Key of the case definition to migrate to
      `caseDefinitionVersion` - Version of the case to migrate to
    Returns:
      Returns the builder
    See Also:
      - `CaseDefinition`

  - ### migrateToCaseDefinition

    HistoricCaseInstanceMigrationBuilder migrateToCaseDefinition(String caseDefinitionKey, int caseDefinitionVersion, String caseDefinitionTenantId)
    Specifies the case definition to migrate to, identified by its key and version and tenantId
    Parameters:
      `caseDefinitionKey` - Key of the case definition to migrate to
      `caseDefinitionVersion` - Version of the case to migrate to
      `caseDefinitionTenantId` - Tenant id of the case definition, must be part of the same tenant
    Returns:
      Returns the builder
    See Also:
      - `CaseDefinition`

  - ### withMigrateToCaseDefinitionTenantId

    HistoricCaseInstanceMigrationBuilder withMigrateToCaseDefinitionTenantId(String caseDefinitionTenantId)
    Specifies the tenantId of the case definition to migrate to
    Parameters:
      `caseDefinitionTenantId` - Tenant id of the case definition, must be part of the same tenant
    Returns:
      Returns the builder

  - ### getHistoricCaseInstanceMigrationDocument

    HistoricCaseInstanceMigrationDocument getHistoricCaseInstanceMigrationDocument()
    Builds a HistoricCaseInstanceMigrationDocument
    Returns:
      Returns the builder
    See Also:
      - `HistoricCaseInstanceMigrationDocument`

  - ### migrate

    void migrate(String caseInstanceId)
    Starts the case instance migration for a case identified with the submitted caseInstanceId
    Parameters:
      `caseInstanceId` -

  - ### migrateHistoricCaseInstances

    void migrateHistoricCaseInstances(String caseDefinitionId)
    Asynchronously starts the case instance migration for each case instances of a given case definition identified by the case definition id.
    Parameters:
      `caseDefinitionId` -

  - ### batchMigrateHistoricCaseInstances

    Batch batchMigrateHistoricCaseInstances(String caseDefinitionId)
    Starts the case instance migration for all case instances of a given case definition identified by the case definition id.
    Parameters:
      `caseDefinitionId` -

  - ### migrateHistoricCaseInstances

    void migrateHistoricCaseInstances(String caseDefinitionKey, int caseDefinitionVersion, String caseDefinitionTenantId)
    Starts the case instance migration for all case instances of a given case definition identified by the case definition key and version (optional tenantId).
    Parameters:
      `caseDefinitionKey` -
      `caseDefinitionVersion` -
      `caseDefinitionTenantId` -

  - ### batchMigrateHistoricCaseInstances

    Batch batchMigrateHistoricCaseInstances(String caseDefinitionKey, int caseDefinitionVersion, String caseDefinitionTenantId)
    Asynchronously starts the case instance migration for each case instances of a given case definition identified by the case definition key and version (optional tenantId).
    Parameters:
      `caseDefinitionKey` -
      `caseDefinitionVersion` -
      `caseDefinitionTenantId` -
    Returns:
      an id of the created batch entity